; To build:
; gsc -cc-options "-iframeworkGLUT -iframeworkOpenGL" -ld-options "-framework GLUT -framework OpenGL" -exe test.scm

;(include "gl_binding.scm")
;(include "glut_binding.scm")
(import gl-binding)
(import glut-binding)

(c-define (c-reshape-callback width height) (int int) void "c_reshape_callback" "static"
    (glViewport 0 0 width height)
    (let*
        (
            (minimum-dimension (exact->inexact (min width height)))
            (n-width (/ (exact->inexact width) minimum-dimension))
            (n-height (/ (exact->inexact height) minimum-dimension))
        )
        (glMatrixMode GL_PROJECTION)
        (glLoadIdentity)
        (glOrtho
            (- n-width) (+ n-width)
            (- n-height) (+ n-height)
            1.0 -1.0
        )
    )
    (glutPostRedisplay)
)


(define frame-number 0)
(define frame-interval 20)

(define (gl-quad left right bottom top)
    (glBegin GL_QUADS)
    (glVertex2f left bottom)
    (glVertex2f right bottom)
    (glVertex2f right top)
    (glVertex2f left top)
    (glEnd)
)

(define (draw-some-quads)
    (gl-quad -0.5 -0.1 -0.5 -0.1)
    (gl-quad 0.1 0.5 -0.5 -0.1)
    (gl-quad -0.5 -0.1 0.1 0.5)
    (gl-quad 0.1 0.5 0.1 0.5)
)

(c-define (c-display-callback) () void "c_display_callback" "static"
    (glClearColor 0.0 1.0 1.0 1.0)
    (glClear GL_COLOR_BUFFER_BIT)
    (glMatrixMode GL_MODELVIEW)
    (glLoadIdentity)
    (glRotatef (exact->inexact frame-number) 0.0 0.0 1.0)
    (draw-some-quads)
    (glFlush)
)

(define (enqueue-timer-callback)
    (glutTimerFunc frame-interval timer-callback 0)
)

(c-define (timer-callback user-value) (int) void "timer_callback" "static"
    (set! frame-number (+ frame-number 1))
    (glutPostRedisplay)
    (enqueue-timer-callback)
)

; Set up GLUT.
(glutInit)
(glutInitDisplayMode GLUT_RGB)
(glutInitWindowSize 300 300)

(glutCreateWindow "Gambit Window")
(glutReshapeFunc c-reshape-callback)
(glutDisplayFunc c-display-callback)
(enqueue-timer-callback)
(glutMainLoop)
